/*
 * wnix, a Unix-like operating system for WebAssembly applications.
 * Copyright (C) 2025  Xavier Del Campo Romero
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#include <drv/event.h>
#include <drv/stdin.h>
#include <drv/stdin/ops.h>
#include <drv/stdin/types.h>
#include <stdbool.h>

static int init(struct drv_port *const p)
{
    if (p->init)
        return 0;

    const struct drv_event *const ev = &p->ev;
    const struct drv_event_ops ops =
    {
        .read = drv_stdin_read,
        .p = p
    };

    if (ev->status("stdin", &ops, true, 0666, ev->args))
        return -1;

    p->init = true;
    return 0;
}

int drv_stdin_update(struct drv_port *const p)
{
    return init(p);
}
